#!/usr/bin/env python
#
# Data Quality Checker also known as DQC
#
# Read the README.md for more detailed information
#
# Barcerlona Supercomputing Center - Centro Nacional de Supercomputacion
#        Earth Sciences Department - Computational Earth Sciences
#     
#     Authors: Ivan Jose Cernicharo Ortiz (ivan.cernicharo@bsc.es)
#             -
#             -
#

import sys
import logging
import os
import subprocess

class standard_compliance_test:

    def __init__(self,type=None,files):
        self.name = type
        self.files = files

    def run_cfchecker(item):
        cmd0 = "cfchecks --version auto %s" %ncfile

        p0 = Popen(
            cmd0, shell=True,
            stdout=subprocess.PIPE,
            stderr=subprocess.STDOUT
            )

        out0, _ = p0.communicate()

        return out0

    def netcdf_test(args):
        from subprocess import Popen

        output = list()
        for ncfile in args:

            out0 = run_cfchecker(ncfile)

            string = str(out0).replace('\'',"").replace("\"","").split('\\n')
            if any('ERROR:' in e for e in string):
                err = [item.split('ERROR:')[-1].strip() for item in string if item.startswith('ERROR:')]
                errstring = ncfile.split('/')[-1] + ' has ' + str(len(err))
                errstring += ' error messages' + '\n'
                errstring += '\n'.join(err)
                print(errstring)
                output.append(errstring)
            else:
                pass
            # We are only interested on errors but could be interesting for 
            # further versions of the dqc_checker to analyze the warnings 
            # and info messages
            # wrn = [item.split('WARN:')[-1].strip() for item in string if item.startswith('WARN:')]
            # inf = [item.split('INFO:')[-1].strip() for item in string if item.startswith('INFO:')]

    def grib_test(args):
        from utils.grib_checker import grib_cck

        for gribfile in args:
            grib_cck.run(gribfile)


    def main(self):
        if self.type != None:

            if self.type == 'CF':
                ncfiles = [item for item in self.files if item.endswith('.nc')]
                if ncfiles != []:
                    netcdf_test(ncfiles)
                else:
                    raise Exception('No NetCDF files in the given input')

            if self.type == 'grib':
                gribfiles = [item for item in self.files if item.endswith('.grib')]
                if gribfiles != []:
                    grib_test(gribfiles)
                else:
                    raise Exception('No GRIB files in the given input')

        else:
            sys.exit()

if __name__ == "__main__":
    sys.exit()