#!/usr/bin/env python
#
# Data Quality Checker also known as DQC
#
# Read the README.md for more detailed information
#
# Barcerlona Supercomputing Center - Centro Nacional de Supercomputacion
#        Earth Sciences Department - Computational Earth Sciences
#     
#     Authors: Ivan Jose Cernicharo Ortiz (ivan.cernicharo@bsc.es)
#             -
#             -
#

import sys
import logging
import os
import subprocess

# check leadtimes or frequency of the variable
class temporal_consistency_test:

    def __init__(self,type,files):
        self.type = type
        self.files = files

    def netcdf_test(args):

    def grib_test(args):

    def main(self):
        if self.type != None:

            if self.type == 'CF':
                ncfiles = [item for item in self.files if item.endswith('.nc')]
                if ncfiles != []:
                    netcdf_test(ncfiles)
                else:
                    raise Exception('No NetCDF files in the given input')

            if self.type == 'grib':
                gribfiles = [item for item in self.files if item.endswith('.grib')]
                if gribfiles != []:
                    grib_test(gribfiles)
                else:
                    raise Exception('No GRIB files in the given input')

        else:
            sys.exit()

if __name__ == "__main__":
    sys.exit()